---
product: "AG Charts"
title: "Flash On Update"
description: "Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed."
enterprise: true
framework: javascript
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/selection/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Flash On Update

Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed.

## Enabling Flash On Update

Flash on Update is disabled by default. To enable it, set `flashOnUpdate.enabled` to `true`.

#### Flash On Update

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  OrdinalTimeAxisModule,
} from "ag-charts-enterprise";
import { applyLiveUpdate, getInitialData } from "./data";

ModuleRegistry.registerModules([
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getInitialData(),
  title: {
    text: "AAPL Stock Price",
  },
  series: [
    {
      type: "candlestick",
      xKey: "date",
      xName: "Date",
      openKey: "open",
      highKey: "high",
      lowKey: "low",
      closeKey: "close",
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: ({ value }) => `$${Number(value).toFixed(0)}`,
      },
    },
  },
  flashOnUpdate: {
    enabled: true,
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function update() {
  options.data = applyLiveUpdate(options.data!);

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).update = update;
}
```

[Live example: Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/typescript/flash-on-update/examples/flash-on-update/)

```js
{
    flashOnUpdate: {
        enabled: true,
    },
}
```

## Category Flash

Flashing just the category band makes it easier to identify which categories have changed. Set `item` to `'category'` to enable this.

#### Category Flash

```ts
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import {
  AgCartesianChartOptions,
  AgCharts,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
} from "ag-charts-enterprise";
import { DataType, applyRandomUpdate, getInitialData } from "./data";

let data: DataType[] = getInitialData();
let isRunning = false;
let updateInterval: ReturnType<typeof setInterval> | undefined;
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions<DataType> = {
  data,
  title: {
    text: "Stock Trading Volume",
  },
  series: [
    {
      type: "bar",
      xKey: "ticker",
      yKey: "buyVolume",
      yName: "Buy Volume (M)",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "ticker",
      yKey: "sellVolume",
      yName: "Sell Volume (M)",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        autoRotate: false,
      },
    },
  },
  flashOnUpdate: {
    enabled: true,
    item: "category",
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function update() {
  data = applyRandomUpdate(data);
  options.data = data;

  chart.update(options);
}

function startUpdates() {
  if (isRunning) return;
  isRunning = true;
  updateButton();
  update();
  updateInterval = setInterval(update, 2000);
}

function stopUpdates() {
  if (!isRunning) return;
  isRunning = false;
  updateButton();
  if (updateInterval) {
    clearInterval(updateInterval);
    updateInterval = undefined;
  }
}

function updateButton() {
  const button = document.getElementById("toggleBtn");
  if (button) {
    button.textContent = isRunning ? "Stop Updates" : "Start Updates";
  }
}

function toggleUpdates() {
  if (isRunning) {
    stopUpdates();
  } else {
    startUpdates();
  }
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).toggleUpdates = toggleUpdates;
}
```

[Live example: Category Flash](https://www.ag-grid.com/charts/archive/14.2.0/typescript/flash-on-update/examples/flash-on-update-category/)

```js
{
    flashOnUpdate: {
        enabled: true,
        item: 'category',
    },
}
```

In this example:

- Click 'Start Updates' to begin a simulated data feed that updates 1–3 bars every 2 seconds.
- Only the changed bars flash.
- Click **Stop Updates** to pause the feed.
- Category Flash is only available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-types/#category), [Grouped Category](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-types/#grouped-category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#unit-time) and [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#ordinal-time) axes.

### Adding and Removing Data

Category flash is also triggered when a category is added to the chart. Removing a category does not trigger a flash.

#### Adding and Removing Data

```ts
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import {
  AgCartesianChartOptions,
  AgCharts,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
} from "ag-charts-enterprise";
import { DataType, applyUpdate, getInitialData, getNextSector } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions<DataType> = {
  data: getInitialData(),
  title: {
    text: "Sector Trading Activity",
  },
  series: [
    {
      type: "bar",
      xKey: "sector",
      yKey: "institutional",
      yName: "Institutional ($M)",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "sector",
      yKey: "retail",
      yName: "Retail ($M)",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "sector",
      yKey: "etfFlows",
      yName: "ETF Flows ($M)",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "category",
    },
  },
  flashOnUpdate: {
    enabled: true,
    item: "category",
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function addSector() {
  const next = getNextSector(options.data!);
  if (!next) return;
  options.data = [...options.data!, { ...next }];

  chart.update(options);
}

function removeSector() {
  if (options.data!.length <= 2) return;
  options.data = options.data!.slice(0, -1);

  chart.update(options);
}

function updateSectors() {
  options.data = applyUpdate(options.data!);

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).addSector = addSector;
  (<any>window).removeSector = removeSector;
  (<any>window).updateSectors = updateSectors;
}
```

[Live example: Adding and Removing Data](https://www.ag-grid.com/charts/archive/14.2.0/typescript/flash-on-update/examples/flash-on-update-add-remove/)

In this example:

- Click 'Add Sector' to add a new sector to the chart — the new category flashes on arrival.
- Click 'Remove Sector' to remove the last sector — no flash occurs on removal.
- Click 'Update' to update values for one or two sectors and observe the category flash.

## Customisation

The appearance and timing of the flash effect can be customised.

#### Customisation

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  OhlcSeriesModule,
  OrdinalTimeAxisModule,
} from "ag-charts-enterprise";
import { applyLiveUpdate, getInitialData } from "./data";

let data = getInitialData();
let isRunning = false;
let updateInterval: ReturnType<typeof setInterval> | undefined;
ModuleRegistry.registerModules([
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
  OhlcSeriesModule,
  OrdinalTimeAxisModule,
]);

const options: AgCartesianChartOptions = {
  data,
  title: {
    text: "MSFT Stock Price",
  },
  series: [
    {
      type: "ohlc",
      xKey: "date",
      xName: "Date",
      openKey: "open",
      highKey: "high",
      lowKey: "low",
      closeKey: "close",
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: ({ value }) => `$${Number(value).toFixed(0)}`,
      },
    },
  },
  flashOnUpdate: {
    enabled: true,
    fill: "#ffd6a5",
    flashDuration: 300,
    fadeOutDuration: 700,
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function update() {
  data = applyLiveUpdate(data);
  options.data = data;

  chart.update(options);
}

function startUpdates() {
  if (isRunning) return;
  isRunning = true;
  updateButton();
  update();
  updateInterval = setInterval(update, 2000);
}

function stopUpdates() {
  if (!isRunning) return;
  isRunning = false;
  updateButton();
  if (updateInterval) {
    clearInterval(updateInterval);
    updateInterval = undefined;
  }
}

function updateButton() {
  const button = document.getElementById("toggleBtn");
  if (button) {
    button.textContent = isRunning ? "Stop Updates" : "Start Updates";
  }
}

function toggleUpdates() {
  if (isRunning) {
    stopUpdates();
  } else {
    startUpdates();
  }
}

function setColor(value: string) {
  options.flashOnUpdate!.fill = value;

  chart.update(options);
}

function setFlashDuration(value: string) {
  options.flashOnUpdate!.flashDuration = Number(value);

  chart.update(options);
}

function setFadeDuration(value: string) {
  options.flashOnUpdate!.fadeOutDuration = Number(value);

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).toggleUpdates = toggleUpdates;
  (<any>window).setColor = setColor;
  (<any>window).setFlashDuration = setFlashDuration;
  (<any>window).setFadeDuration = setFadeDuration;
}
```

[Live example: Customisation](https://www.ag-grid.com/charts/archive/14.2.0/typescript/flash-on-update/examples/flash-on-update-customisation/)

```js
{
    flashOnUpdate: {
        enabled: true,
        fill: '#ffd6a5',
        flashDuration: 300,
        fadeOutDuration: 700,
    },
}
```

In this example:

- Use the 'Fill', 'Flash' and 'Fade' controls to adjust the flash appearance.
  - `fill` — the fill colour of the flash overlay.
  - `flashDuration` — how long (in milliseconds) the flash remains at full opacity before fading.
  - `fadeOutDuration` — how long (in milliseconds) the fade-out takes.
- Click 'Start Updates' to begin a simulated live price feed and observe the flash with the current settings.
- Click 'Stop Updates' to pause the feed.

## Animation

Flash on Update disables [Animation](https://www.ag-grid.com/charts/archive/14.2.0/javascript/animation/) by default, as the two are rarely used together. If you do need both, explicitly set `animation: { enabled: true }`.

When both are enabled, the `flashDuration` and `fadeOutDuration` values are scaled to fit within the data update animation phases, so the actual timing may differ from the configured values. Their ratio still controls how the duration is split between the hold and fade stages.

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether the flash effect is enabled. |
| item | 'chart' \| 'category' |  | What part of the chart to flash. |
| fill | CssColor |  | The fill colour of the flash effect. |
| fillOpacity | Opacity |  | The fill opacity of the flash effect. |
| flashDuration | DurationMs |  | The flash hold duration in milliseconds before fading begins. Actual timing may vary when animations are enabled. |
| fadeOutDuration | DurationMs |  | The fade-out duration in milliseconds. Actual timing may vary when animations are enabled. |


---
product: "AG Charts"
title: "Flash On Update"
description: "Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed."
enterprise: true
framework: angular
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/selection/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Flash On Update

Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed.

## Enabling Flash On Update

Flash on Update is disabled by default. To enable it, set `flashOnUpdate.enabled` to `true`.

#### Flash On Update

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/examples/flash-on-update/)

```js
{
    flashOnUpdate: {
        enabled: true,
    },
}
```

## Category Flash

Flashing just the category band makes it easier to identify which categories have changed. Set `item` to `'category'` to enable this.

#### Category Flash

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Category Flash](https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/examples/flash-on-update-category/)

```js
{
    flashOnUpdate: {
        enabled: true,
        item: 'category',
    },
}
```

In this example:

- Click 'Start Updates' to begin a simulated data feed that updates 1–3 bars every 2 seconds.
- Only the changed bars flash.
- Click **Stop Updates** to pause the feed.
- Category Flash is only available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-types/#category), [Grouped Category](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-types/#grouped-category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#unit-time) and [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#ordinal-time) axes.

### Adding and Removing Data

Category flash is also triggered when a category is added to the chart. Removing a category does not trigger a flash.

#### Adding and Removing Data

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Adding and Removing Data](https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/examples/flash-on-update-add-remove/)

In this example:

- Click 'Add Sector' to add a new sector to the chart — the new category flashes on arrival.
- Click 'Remove Sector' to remove the last sector — no flash occurs on removal.
- Click 'Update' to update values for one or two sectors and observe the category flash.

## Customisation

The appearance and timing of the flash effect can be customised.

#### Customisation

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Customisation](https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/examples/flash-on-update-customisation/)

```js
{
    flashOnUpdate: {
        enabled: true,
        fill: '#ffd6a5',
        flashDuration: 300,
        fadeOutDuration: 700,
    },
}
```

In this example:

- Use the 'Fill', 'Flash' and 'Fade' controls to adjust the flash appearance.
  - `fill` — the fill colour of the flash overlay.
  - `flashDuration` — how long (in milliseconds) the flash remains at full opacity before fading.
  - `fadeOutDuration` — how long (in milliseconds) the fade-out takes.
- Click 'Start Updates' to begin a simulated live price feed and observe the flash with the current settings.
- Click 'Stop Updates' to pause the feed.

## Animation

Flash on Update disables [Animation](https://www.ag-grid.com/charts/archive/14.2.0/angular/animation/) by default, as the two are rarely used together. If you do need both, explicitly set `animation: { enabled: true }`.

When both are enabled, the `flashDuration` and `fadeOutDuration` values are scaled to fit within the data update animation phases, so the actual timing may differ from the configured values. Their ratio still controls how the duration is split between the hold and fade stages.

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether the flash effect is enabled. |
| item | 'chart' \| 'category' |  | What part of the chart to flash. |
| fill | CssColor |  | The fill colour of the flash effect. |
| fillOpacity | Opacity |  | The fill opacity of the flash effect. |
| flashDuration | DurationMs |  | The flash hold duration in milliseconds before fading begins. Actual timing may vary when animations are enabled. |
| fadeOutDuration | DurationMs |  | The fade-out duration in milliseconds. Actual timing may vary when animations are enabled. |


---
product: "AG Charts"
title: "Flash On Update"
description: "Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed."
enterprise: true
framework: react
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/selection/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Flash On Update

Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed.

## Enabling Flash On Update

Flash on Update is disabled by default. To enable it, set `flashOnUpdate.enabled` to `true`.

#### Flash On Update

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  OrdinalTimeAxisModule,
} from "ag-charts-enterprise";
import { applyLiveUpdate, getInitialData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getInitialData(),
    title: {
      text: "AAPL Stock Price",
    },
    series: [
      {
        type: "candlestick",
        xKey: "date",
        xName: "Date",
        openKey: "open",
        highKey: "high",
        lowKey: "low",
        closeKey: "close",
      },
    ],
    axes: {
      y: {
        type: "number",
        label: {
          formatter: ({ value }) => `$${Number(value).toFixed(0)}`,
        },
      },
    },
    flashOnUpdate: {
      enabled: true,
    },
  });

  const update = () => {
    const nextOptions = clone(options);

    nextOptions.data = applyLiveUpdate(nextOptions.data!);

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={update}>Update</button>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/flash-on-update/examples/flash-on-update/)

```js
{
    flashOnUpdate: {
        enabled: true,
    },
}
```

## Category Flash

Flashing just the category band makes it easier to identify which categories have changed. Set `item` to `'category'` to enable this.

#### Category Flash

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import {
  AgCartesianChartOptions,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
} from "ag-charts-enterprise";
import { DataType, applyRandomUpdate, getInitialData } from "./data";
import clone from "clone";

let data: DataType[] = getInitialData();
let isRunning = false;
let updateInterval: ReturnType<typeof setInterval> | undefined;
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions<DataType>>({
    data,
    title: {
      text: "Stock Trading Volume",
    },
    series: [
      {
        type: "bar",
        xKey: "ticker",
        yKey: "buyVolume",
        yName: "Buy Volume (M)",
        stacked: true,
      },
      {
        type: "bar",
        xKey: "ticker",
        yKey: "sellVolume",
        yName: "Sell Volume (M)",
        stacked: true,
      },
    ],
    axes: {
      x: {
        type: "category",
        label: {
          autoRotate: false,
        },
      },
    },
    flashOnUpdate: {
      enabled: true,
      item: "category",
    },
  });

  const update = () => {
    const nextOptions = clone(options);

    data = applyRandomUpdate(data);
    nextOptions.data = data;

    setOptions(nextOptions);
  };

  const startUpdates = () => {
    if (isRunning) return;
    isRunning = true;
    updateButton();
    update();
    updateInterval = setInterval(update, 2000);
  };

  const stopUpdates = () => {
    if (!isRunning) return;
    isRunning = false;
    updateButton();
    if (updateInterval) {
      clearInterval(updateInterval);
      updateInterval = undefined;
    }
  };

  const updateButton = () => {
    const button = document.getElementById("toggleBtn");
    if (button) {
      button.textContent = isRunning ? "Stop Updates" : "Start Updates";
    }
  };

  const toggleUpdates = () => {
    if (isRunning) {
      stopUpdates();
    } else {
      startUpdates();
    }
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button id="toggleBtn" onClick={toggleUpdates}>
            Start Updates
          </button>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Category Flash](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/flash-on-update/examples/flash-on-update-category/)

```js
{
    flashOnUpdate: {
        enabled: true,
        item: 'category',
    },
}
```

In this example:

- Click 'Start Updates' to begin a simulated data feed that updates 1–3 bars every 2 seconds.
- Only the changed bars flash.
- Click **Stop Updates** to pause the feed.
- Category Flash is only available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-types/#category), [Grouped Category](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-types/#grouped-category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#unit-time) and [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#ordinal-time) axes.

### Adding and Removing Data

Category flash is also triggered when a category is added to the chart. Removing a category does not trigger a flash.

#### Adding and Removing Data

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import {
  AgCartesianChartOptions,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
} from "ag-charts-enterprise";
import { DataType, applyUpdate, getInitialData, getNextSector } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions<DataType>>({
    data: getInitialData(),
    title: {
      text: "Sector Trading Activity",
    },
    series: [
      {
        type: "bar",
        xKey: "sector",
        yKey: "institutional",
        yName: "Institutional ($M)",
        stacked: true,
      },
      {
        type: "bar",
        xKey: "sector",
        yKey: "retail",
        yName: "Retail ($M)",
        stacked: true,
      },
      {
        type: "bar",
        xKey: "sector",
        yKey: "etfFlows",
        yName: "ETF Flows ($M)",
        stacked: true,
      },
    ],
    axes: {
      x: {
        type: "category",
      },
    },
    flashOnUpdate: {
      enabled: true,
      item: "category",
    },
  });

  const addSector = () => {
    const nextOptions = clone(options);

    const next = getNextSector(nextOptions.data!);
    if (!next) return;
    nextOptions.data = [...nextOptions.data!, { ...next }];

    setOptions(nextOptions);
  };

  const removeSector = () => {
    const nextOptions = clone(options);

    if (nextOptions.data!.length <= 2) return;
    nextOptions.data = nextOptions.data!.slice(0, -1);

    setOptions(nextOptions);
  };

  const updateSectors = () => {
    const nextOptions = clone(options);

    nextOptions.data = applyUpdate(nextOptions.data!);

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={addSector}>Add Sector</button>
          <button onClick={removeSector}>Remove Sector</button>
          <button onClick={updateSectors}>Update</button>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Adding and Removing Data](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/flash-on-update/examples/flash-on-update-add-remove/)

In this example:

- Click 'Add Sector' to add a new sector to the chart — the new category flashes on arrival.
- Click 'Remove Sector' to remove the last sector — no flash occurs on removal.
- Click 'Update' to update values for one or two sectors and observe the category flash.

## Customisation

The appearance and timing of the flash effect can be customised.

#### Customisation

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  OhlcSeriesModule,
  OrdinalTimeAxisModule,
} from "ag-charts-enterprise";
import { applyLiveUpdate, getInitialData } from "./data";
import clone from "clone";

let data = getInitialData();
let isRunning = false;
let updateInterval: ReturnType<typeof setInterval> | undefined;
ModuleRegistry.registerModules([
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
  OhlcSeriesModule,
  OrdinalTimeAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data,
    title: {
      text: "MSFT Stock Price",
    },
    series: [
      {
        type: "ohlc",
        xKey: "date",
        xName: "Date",
        openKey: "open",
        highKey: "high",
        lowKey: "low",
        closeKey: "close",
      },
    ],
    axes: {
      y: {
        type: "number",
        label: {
          formatter: ({ value }) => `$${Number(value).toFixed(0)}`,
        },
      },
    },
    flashOnUpdate: {
      enabled: true,
      fill: "#ffd6a5",
      flashDuration: 300,
      fadeOutDuration: 700,
    },
  });

  const update = () => {
    const nextOptions = clone(options);

    data = applyLiveUpdate(data);
    nextOptions.data = data;

    setOptions(nextOptions);
  };

  const startUpdates = () => {
    if (isRunning) return;
    isRunning = true;
    updateButton();
    update();
    updateInterval = setInterval(update, 2000);
  };

  const stopUpdates = () => {
    if (!isRunning) return;
    isRunning = false;
    updateButton();
    if (updateInterval) {
      clearInterval(updateInterval);
      updateInterval = undefined;
    }
  };

  const updateButton = () => {
    const button = document.getElementById("toggleBtn");
    if (button) {
      button.textContent = isRunning ? "Stop Updates" : "Start Updates";
    }
  };

  const toggleUpdates = () => {
    if (isRunning) {
      stopUpdates();
    } else {
      startUpdates();
    }
  };

  const setColor = (value: string) => {
    const nextOptions = clone(options);

    nextOptions.flashOnUpdate!.fill = value;

    setOptions(nextOptions);
  };

  const setFlashDuration = (value: string) => {
    const nextOptions = clone(options);

    nextOptions.flashOnUpdate!.flashDuration = Number(value);

    setOptions(nextOptions);
  };

  const setFadeDuration = (value: string) => {
    const nextOptions = clone(options);

    nextOptions.flashOnUpdate!.fadeOutDuration = Number(value);

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button id="toggleBtn" onClick={toggleUpdates}>
            Start Updates
          </button>
          <label>Fill:</label>
          <select onChange={(event) => setColor(event.target.value)}>
            <option value="#cfeeff">Default (#cfeeff)</option>
            <option value="#ffd6a5">Warm (#ffd6a5)</option>
            <option value="#ffadad">Red (#ffadad)</option>
          </select>
          <label>Flash:</label>
          <select onChange={(event) => setFlashDuration(event.target.value)}>
            <option value="0">0ms</option>
            <option value="100">100ms</option>
            <option value="300">300ms</option>
            <option value="500">500ms</option>
          </select>
          <label>Fade:</label>
          <select onChange={(event) => setFadeDuration(event.target.value)}>
            <option value="200">200ms</option>
            <option value="500">500ms</option>
            <option value="700">700ms</option>
            <option value="1500">1500ms</option>
          </select>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Customisation](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/flash-on-update/examples/flash-on-update-customisation/)

```js
{
    flashOnUpdate: {
        enabled: true,
        fill: '#ffd6a5',
        flashDuration: 300,
        fadeOutDuration: 700,
    },
}
```

In this example:

- Use the 'Fill', 'Flash' and 'Fade' controls to adjust the flash appearance.
  - `fill` — the fill colour of the flash overlay.
  - `flashDuration` — how long (in milliseconds) the flash remains at full opacity before fading.
  - `fadeOutDuration` — how long (in milliseconds) the fade-out takes.
- Click 'Start Updates' to begin a simulated live price feed and observe the flash with the current settings.
- Click 'Stop Updates' to pause the feed.

## Animation

Flash on Update disables [Animation](https://www.ag-grid.com/charts/archive/14.2.0/react/animation/) by default, as the two are rarely used together. If you do need both, explicitly set `animation: { enabled: true }`.

When both are enabled, the `flashDuration` and `fadeOutDuration` values are scaled to fit within the data update animation phases, so the actual timing may differ from the configured values. Their ratio still controls how the duration is split between the hold and fade stages.

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether the flash effect is enabled. |
| item | 'chart' \| 'category' |  | What part of the chart to flash. |
| fill | CssColor |  | The fill colour of the flash effect. |
| fillOpacity | Opacity |  | The fill opacity of the flash effect. |
| flashDuration | DurationMs |  | The flash hold duration in milliseconds before fading begins. Actual timing may vary when animations are enabled. |
| fadeOutDuration | DurationMs |  | The fade-out duration in milliseconds. Actual timing may vary when animations are enabled. |


---
product: "AG Charts"
title: "Flash On Update"
description: "Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed."
enterprise: true
framework: vue
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/selection/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Flash On Update

Flash on Update signals that chart data has changed by briefly overlaying a flash animation, drawing the user's attention to the chart whenever data is updated, added or removed.

## Enabling Flash On Update

Flash on Update is disabled by default. To enable it, set `flashOnUpdate.enabled` to `true`.

#### Flash On Update

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  OrdinalTimeAxisModule,
} from "ag-charts-enterprise";
import { applyLiveUpdate, getInitialData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="update()">Update</button>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getInitialData(),
      title: {
        text: "AAPL Stock Price",
      },
      series: [
        {
          type: "candlestick",
          xKey: "date",
          xName: "Date",
          openKey: "open",
          highKey: "high",
          lowKey: "low",
          closeKey: "close",
        },
      ],
      axes: {
        y: {
          type: "number",
          label: {
            formatter: ({ value }) => `$${Number(value).toFixed(0)}`,
          },
        },
      },
      flashOnUpdate: {
        enabled: true,
      },
    });

    const update = () => {
      const optionsCopy = clone(options.value);

      optionsCopy.data = applyLiveUpdate(optionsCopy.data);

      options.value = optionsCopy;
    };

    return {
      options,
      update,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/vue3/flash-on-update/examples/flash-on-update/)

```js
{
    flashOnUpdate: {
        enabled: true,
    },
}
```

## Category Flash

Flashing just the category band makes it easier to identify which categories have changed. Set `item` to `'category'` to enable this.

#### Category Flash

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import {
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
} from "ag-charts-enterprise";
import { applyRandomUpdate, getInitialData } from "./data";
import clone from "clone";

let data = getInitialData();

let isRunning = false;

let updateInterval;

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button id="toggleBtn" v-on:click="toggleUpdates()">Start Updates</button>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions<DataType>>({
      data,
      title: {
        text: "Stock Trading Volume",
      },
      series: [
        {
          type: "bar",
          xKey: "ticker",
          yKey: "buyVolume",
          yName: "Buy Volume (M)",
          stacked: true,
        },
        {
          type: "bar",
          xKey: "ticker",
          yKey: "sellVolume",
          yName: "Sell Volume (M)",
          stacked: true,
        },
      ],
      axes: {
        x: {
          type: "category",
          label: {
            autoRotate: false,
          },
        },
      },
      flashOnUpdate: {
        enabled: true,
        item: "category",
      },
    });

    const update = () => {
      const optionsCopy = clone(options.value);

      data = applyRandomUpdate(data);
      optionsCopy.data = data;

      options.value = optionsCopy;
    };
    const startUpdates = () => {
      if (isRunning) return;
      isRunning = true;
      updateButton();
      update();
      updateInterval = setInterval(update, 2000);
    };
    const stopUpdates = () => {
      if (!isRunning) return;
      isRunning = false;
      updateButton();
      if (updateInterval) {
        clearInterval(updateInterval);
        updateInterval = undefined;
      }
    };
    const updateButton = () => {
      const button = document.getElementById("toggleBtn");
      if (button) {
        button.textContent = isRunning ? "Stop Updates" : "Start Updates";
      }
    };
    const toggleUpdates = () => {
      if (isRunning) {
        stopUpdates();
      } else {
        startUpdates();
      }
    };

    return {
      options,
      toggleUpdates,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Category Flash](https://www.ag-grid.com/charts/archive/14.2.0/vue3/flash-on-update/examples/flash-on-update-category/)

```js
{
    flashOnUpdate: {
        enabled: true,
        item: 'category',
    },
}
```

In this example:

- Click 'Start Updates' to begin a simulated data feed that updates 1–3 bars every 2 seconds.
- Only the changed bars flash.
- Click **Stop Updates** to pause the feed.
- Category Flash is only available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-types/#category), [Grouped Category](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-types/#grouped-category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#unit-time) and [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#ordinal-time) axes.

### Adding and Removing Data

Category flash is also triggered when a category is added to the chart. Removing a category does not trigger a flash.

#### Adding and Removing Data

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import {
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
} from "ag-charts-enterprise";
import { applyUpdate, getInitialData, getNextSector } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="addSector()">Add Sector</button>
        <button v-on:click="removeSector()">Remove Sector</button>
        <button v-on:click="updateSectors()">Update</button>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions<DataType>>({
      data: getInitialData(),
      title: {
        text: "Sector Trading Activity",
      },
      series: [
        {
          type: "bar",
          xKey: "sector",
          yKey: "institutional",
          yName: "Institutional ($M)",
          stacked: true,
        },
        {
          type: "bar",
          xKey: "sector",
          yKey: "retail",
          yName: "Retail ($M)",
          stacked: true,
        },
        {
          type: "bar",
          xKey: "sector",
          yKey: "etfFlows",
          yName: "ETF Flows ($M)",
          stacked: true,
        },
      ],
      axes: {
        x: {
          type: "category",
        },
      },
      flashOnUpdate: {
        enabled: true,
        item: "category",
      },
    });

    const addSector = () => {
      const optionsCopy = clone(options.value);

      const next = getNextSector(optionsCopy.data);
      if (!next) return;
      optionsCopy.data = [...optionsCopy.data, { ...next }];

      options.value = optionsCopy;
    };
    const removeSector = () => {
      const optionsCopy = clone(options.value);

      if (optionsCopy.data.length <= 2) return;
      optionsCopy.data = optionsCopy.data.slice(0, -1);

      options.value = optionsCopy;
    };
    const updateSectors = () => {
      const optionsCopy = clone(options.value);

      optionsCopy.data = applyUpdate(optionsCopy.data);

      options.value = optionsCopy;
    };

    return {
      options,
      addSector,
      removeSector,
      updateSectors,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Adding and Removing Data](https://www.ag-grid.com/charts/archive/14.2.0/vue3/flash-on-update/examples/flash-on-update-add-remove/)

In this example:

- Click 'Add Sector' to add a new sector to the chart — the new category flashes on arrival.
- Click 'Remove Sector' to remove the last sector — no flash occurs on removal.
- Click 'Update' to update values for one or two sectors and observe the category flash.

## Customisation

The appearance and timing of the flash effect can be customised.

#### Customisation

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  OhlcSeriesModule,
  OrdinalTimeAxisModule,
} from "ag-charts-enterprise";
import { applyLiveUpdate, getInitialData } from "./data";
import clone from "clone";

let data = getInitialData();

let isRunning = false;

let updateInterval;

ModuleRegistry.registerModules([
  ContextMenuModule,
  CrosshairModule,
  FlashOnUpdateModule,
  LegendModule,
  NumberAxisModule,
  OhlcSeriesModule,
  OrdinalTimeAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button id="toggleBtn" v-on:click="toggleUpdates()">Start Updates</button>
        <label>Fill:</label>
        <select v-on:change="setColor($event.target.value)">
          <option value="#cfeeff">Default (#cfeeff)</option>
          <option value="#ffd6a5" selected="">Warm (#ffd6a5)</option>
          <option value="#ffadad">Red (#ffadad)</option>
        </select>
        <label>Flash:</label>
        <select v-on:change="setFlashDuration($event.target.value)">
          <option value="0">0ms</option>
          <option value="100">100ms</option>
          <option value="300" selected="">300ms</option>
          <option value="500">500ms</option>
        </select>
        <label>Fade:</label>
        <select v-on:change="setFadeDuration($event.target.value)">
          <option value="200">200ms</option>
          <option value="500">500ms</option>
          <option value="700" selected="">700ms</option>
          <option value="1500">1500ms</option>
        </select>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data,
      title: {
        text: "MSFT Stock Price",
      },
      series: [
        {
          type: "ohlc",
          xKey: "date",
          xName: "Date",
          openKey: "open",
          highKey: "high",
          lowKey: "low",
          closeKey: "close",
        },
      ],
      axes: {
        y: {
          type: "number",
          label: {
            formatter: ({ value }) => `$${Number(value).toFixed(0)}`,
          },
        },
      },
      flashOnUpdate: {
        enabled: true,
        fill: "#ffd6a5",
        flashDuration: 300,
        fadeOutDuration: 700,
      },
    });

    const update = () => {
      const optionsCopy = clone(options.value);

      data = applyLiveUpdate(data);
      optionsCopy.data = data;

      options.value = optionsCopy;
    };
    const startUpdates = () => {
      if (isRunning) return;
      isRunning = true;
      updateButton();
      update();
      updateInterval = setInterval(update, 2000);
    };
    const stopUpdates = () => {
      if (!isRunning) return;
      isRunning = false;
      updateButton();
      if (updateInterval) {
        clearInterval(updateInterval);
        updateInterval = undefined;
      }
    };
    const updateButton = () => {
      const button = document.getElementById("toggleBtn");
      if (button) {
        button.textContent = isRunning ? "Stop Updates" : "Start Updates";
      }
    };
    const toggleUpdates = () => {
      if (isRunning) {
        stopUpdates();
      } else {
        startUpdates();
      }
    };
    const setColor = (value) => {
      const optionsCopy = clone(options.value);

      optionsCopy.flashOnUpdate.fill = value;

      options.value = optionsCopy;
    };
    const setFlashDuration = (value) => {
      const optionsCopy = clone(options.value);

      optionsCopy.flashOnUpdate.flashDuration = Number(value);

      options.value = optionsCopy;
    };
    const setFadeDuration = (value) => {
      const optionsCopy = clone(options.value);

      optionsCopy.flashOnUpdate.fadeOutDuration = Number(value);

      options.value = optionsCopy;
    };

    return {
      options,
      toggleUpdates,
      setColor,
      setFlashDuration,
      setFadeDuration,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Customisation](https://www.ag-grid.com/charts/archive/14.2.0/vue3/flash-on-update/examples/flash-on-update-customisation/)

```js
{
    flashOnUpdate: {
        enabled: true,
        fill: '#ffd6a5',
        flashDuration: 300,
        fadeOutDuration: 700,
    },
}
```

In this example:

- Use the 'Fill', 'Flash' and 'Fade' controls to adjust the flash appearance.
  - `fill` — the fill colour of the flash overlay.
  - `flashDuration` — how long (in milliseconds) the flash remains at full opacity before fading.
  - `fadeOutDuration` — how long (in milliseconds) the fade-out takes.
- Click 'Start Updates' to begin a simulated live price feed and observe the flash with the current settings.
- Click 'Stop Updates' to pause the feed.

## Animation

Flash on Update disables [Animation](https://www.ag-grid.com/charts/archive/14.2.0/vue/animation/) by default, as the two are rarely used together. If you do need both, explicitly set `animation: { enabled: true }`.

When both are enabled, the `flashDuration` and `fadeOutDuration` values are scaled to fit within the data update animation phases, so the actual timing may differ from the configured values. Their ratio still controls how the duration is split between the hold and fade stages.

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether the flash effect is enabled. |
| item | 'chart' \| 'category' |  | What part of the chart to flash. |
| fill | CssColor |  | The fill colour of the flash effect. |
| fillOpacity | Opacity |  | The fill opacity of the flash effect. |
| flashDuration | DurationMs |  | The flash hold duration in milliseconds before fading begins. Actual timing may vary when animations are enabled. |
| fadeOutDuration | DurationMs |  | The fade-out duration in milliseconds. Actual timing may vary when animations are enabled. |
